//*PMRawBegin
#include "textures.inc"
#include "colors.inc"
#include "woods.inc"
#include "glass.inc"
#include "metals.inc"
//*PMRawEnd

global_settings {
   adc_bailout 0.0039216
   ambient_light rgb <1.5, 1.5, 1.5>
   assumed_gamma 1.5
   noise_generator 1
}

light_source {
   //*PMName sansOmbre
   <-0.537011, 7.28776, -8.66409>, rgb <1, 1, 1>
   shadowless
}

camera {
   perspective
   location <0, 0.320349, -3.75552>
   sky <0, 1, 0>
   direction <0, 0, 1>
   right <2, 0, 0>
   up <0, 1.5, 0>
   look_at <-0.0868729, -0.0782424, 1.64339>
   angle 90
}

#declare boisMasque = texture {
   //*PMRawBegin
   
               T_Wood12// T_Wood14 //T_Wood21
               finish { specular 0.35 roughness 0.05 ambient 0.3 }
               //translate x*1
               rotate <0, 0, 0>
               //translate y*2
               
   //*PMRawEnd
   scale 300
}

#declare peintureMasque = texture {
   pigment {
      color rgb <1, 1, 1>
   }
}

plane {
   <0, 0, -1>, -4
   
   pigment {
      color rgb <1, 0.8, 0.5>
   }
   scale 1
   rotate <0, 0, 0>
   translate <0, 0, 0>
}

#declare oreille = difference {
   box {
      <-0.35, -0.3, -0.1>, <0, 0.3, 0.1>
      scale 1
      rotate <0, 0, 0>
      translate x*(-0.29051)
   }
   
   box {
      <-0.5, -0.5, -0.5>, <0.5, 0.5, 0.5>
      scale <0.3, 0.3, 1>
      rotate z*45
      translate <-0.42761, 0.3, 0>
   }
   
   box {
      <-0.5, -0.5, -0.5>, <0.5, 0.5, 0.5>
      scale <0.3, 0.3, 1>
      rotate z*45
      translate <-0.42761, -0.3, 0>
   }
   translate x*0.05
}

#declare masqueOri = union {
   difference {
      union {
         sphere {
            <0, 0, 0>, 0.5
            scale <1, 1.5, 0.6>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         box {
            //*PMName nez
            <-0.2, -0.2, -0.2>, <0.2, 0.2, 0.2>
            rotate <-29.5, 41, -20.4>
            rotate x*45
            scale 1
            translate <0, -0.0290184, -0.0580367>
         }
         
         object {
            oreille
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         object {
            oreille
            scale 1
            rotate y*180
            translate <0, 0, 0>
         }
      }
      
      sphere {
         <0, 0, 0>, 0.48
         scale <1, 1.5, 0.6>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName arriere
         <-1, -1, 0>, <1, 1, 0.5>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         <-0.1, -0.1, -0.5>, <0.1, 0.1, 0.5>
         rotate z*45
         scale <1, 0.4, 1>
         translate <-0.174412, 0.251359, 0>
      }
      
      box {
         <-0.1, -0.1, -0.5>, <0.1, 0.1, 0.5>
         rotate z*45
         scale <1, 0.4, 1>
         translate <0.17441, 0.25136, 0>
      }
      
      box {
         <-0.2, -0.2, -0.5>, <0.2, 0.2, 0.5>
         rotate z*45
         scale <1, 0.2, 1>
         translate y*(-0.430712)
      }
   }
}

#declare peintureDuMasque = union {
   intersection {
      object {
         masqueOri
         scale 1.001
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      union {
         box {
            <-0.2, -0.2, -0.5>, <0.2, 0.2, 0.5>
            rotate z*45
            scale <0.8, 0.2, 1>
            translate y*0.488247
         }
         
         box {
            <-0.2, -0.2, -0.5>, <0.2, 0.2, 0.5>
            rotate z*45
            scale <0.2, 0.8, 1>
            translate <-0.30632, -0.095675, 0>
         }
         
         box {
            <-0.2, -0.2, -0.5>, <0.2, 0.2, 0.5>
            rotate z*45
            scale <0.2, 0.8, 1>
            translate <0.30632, -0.095675, 0>
         }
      }
   }
}

#declare masquePeint = union {
   object {
      masqueOri
      
      texture {
         boisMasque
      }
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      peintureDuMasque
      
      texture {
         peintureMasque
      }
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
}

object {
   masquePeint
   scale 1
   rotate <0, 0, 0>
   translate <0, 0, 0>
}